{######################################################}
{##\ ______________________________________________ /##}
{## |                                              | ##}
{## |  autor: Sebastian Stoff                      | ##}
{## |  unit : GUI - Obsluga interface graficznego  | ##}
{## |  ver  : 1.0                                  | ##}
{## |______________________________________________| ##}
{##/                                                \##}
{######################################################}
{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit gui;

interface
uses Crt,Dos,BgiChr,Mouse,Basic;
type TMouse=object
       mx,my : Integer;
       mb    : Byte;
         procedure RefreshMouse;
     end;
     TShapes=object(TMouse)
       procedure ShLine(x1,y1,x2,y2 : Integer);
       procedure ShBorder(x1,y1,x2,y2 : Integer; pressed,default : Boolean);
     end;
     TDisplay=object(TShapes)
       consol : record
         x,y   : Integer;
         width : Integer;
         height: Integer;
       end;
       x,y   : Integer;
       xPlot : Integer;
       yPlot : Integer;
       histP : Byte;
       hist  : array[1..50] of record
                 mi : Byte;
                 pg : Byte;
               end;
       aa    : record
                 h : Byte; {size}
                 f : Byte; {font}
                 j : Byte; {0-left  1-center  2-right}
                 c : Byte;
                 s : Byte; {0-norm 1-bold}
               end;
       width : Integer;
       height: Integer;
       XTPage, XTTotal  : Integer;
       XTList           : array[1..50] of Integer;
       XTFile           : String[30];
       title1,title2 : String[50];
         procedure Draw(x1,y1,hgh : Integer);
         procedure NewTitle(t1,t2:String);
         function LoadXT(fn : String):Byte;
         function LoadXTpg(nr : Byte):Byte;
         procedure XTNxtPage;
         procedure XTPrvPage;
         procedure HsNxtPage;
         procedure HsPrvPage;
         function Load16c(fn : String; oft : LongInt):Byte;
     end;
     TMenu=object(TShapes)
       x,y   : Integer;
       width : Integer;
       height: Integer;
       lastLighted: Byte;
       aItem : Integer;
       items : array[1..30] of record
         depth : Byte;
         title : String[35];
         fileN : String[35];
         kind  : Byte; {0-norm; 1-info; 2-help; 3-wstep}
         is    : Boolean;
       end;
         procedure Draw(x1,y1,x2,y2 : Integer; tit : String);
         procedure AddItem(tit,des,fn : String; d,k : Byte);
         procedure FollowMouse;
         procedure MouseOut;
         procedure Refresh;
         procedure RefreshItems;
         procedure Choose;
     end;
     PObj=^TZone;
     TZone=object(TShapes)
       id          : Word;
       x1,y1,x2,y2 : Integer;
       OnClick     : Procedure;
       OnMoveIn    : Procedure;
       OnMoveOut   : Procedure;
       key         : set of Byte;
       desc        : String[80];
       kind        : Byte;{1=zone 2=buttom}
       nxt         : PObj;
       text,text2  : String[30];
       pressed     : Boolean;
       default     : Boolean;
         procedure Draw;
         procedure PressButton;
         procedure Add;
     end;
     TApplication=object(TShapes)
       colorBG,colorBT,colorTX : Byte;
       color1,color2           : Byte;
       mode                    : Byte;
       keyP                    : Byte;
       nxtid                   : Word;
       activeItem              : TZone;
       lastActiveItem          : TZone;
       title,copyright         : String[80];
       hint1,hint2,oldHint1,oldHint2 : String;
       clock                   : Boolean;
       oldClock                : String;
       finished                : Boolean;
         procedure Nop;
         procedure Init;
         procedure Draw;
         procedure finish;
         procedure Done;
         procedure RefreshClock;
         procedure NewHint(msg1,msg2 : String);
         procedure RefreshHint;
         function LookMouse(obj : TZone):Boolean;
         procedure Objects;
         procedure KillAll;
     end;
procedure OutTextXY(x,y : Integer; txt : String);

var app             : TApplication;
    menu            : TMenu;
    disp            : TDisplay;
    fifo,fifoC,objT : PObj;
    ppp             : Pointer;
implementation
uses Graph;

procedure TShapes.ShLine;
begin
  HideMouse;
  SetColor(app.color1);
  Line(x1,y1,x2,y2);
  SetColor(app.color2);
  Line(x1+1,y1+1,x2+1,y2+1);
  ShowMouse;
end;

procedure TShapes.ShBorder;
begin
  HideMouse;

  if pressed then SetColor(app.color2) else SetColor(app.color1);
  Line(x1,y1,x2,y1);
  Line(x1,y1,x1,y2);
  if default then begin
    Line(x1+1,y1+1,x2-1,y1+1);
    Line(x1+1,y1+1,x1+1,y2-1);
  end;

  if pressed then SetColor(app.color1) else SetColor(app.color2);
  Line(x1,y2,x2,y2);
  Line(x2,y1,x2,y2);
  if default then begin
    Line(x1+1,y2-1,x2-1,y2-1);
    Line(x2-1,y1+1,x2-1,y2-1);
  end;
  ShowMouse;
end;

procedure TApplication.Nop;
begin
end;

procedure TApplication.Init;
var gd,gm : Integer;
    r     : Registers;
begin
  r.ax:=$00;
  intr($33,r);
  if r.ax=0 then begin
    beep;
    writeln('Brak myszki!');
    Halt;
  end;
  if not isvga then begin
    beep;
    writeln('Brak karty VGA!');
    Halt;
  end;

  gd:=9;
  gm:=mode;
  Randomize;
  InitGraph(gd,gm,'');
  Draw;
  ShowMouse;
end;

procedure TApplication.finish;
begin
  app.finished:=True;
end;

procedure finish_; far;
begin
  app.finish;
end;

procedure Info; far;
var i : Integer;
begin
  with menu do begin
    if items[aItem].kind=1 then Exit;
    for i:=1 to 30 do if items[i].kind=1 then begin
      aItem:=i;
      RefreshItems;
      disp.LoadXT(items[aItem].fileN);
      disp.LoadXTpg(1);
    end;
  end;
end;

procedure Help; far;
var i : Integer;
begin
  with menu do begin
    if items[aItem].kind=2 then Exit;
    for i:=1 to 30 do if items[i].kind=2 then begin
      aItem:=i;
      RefreshItems;
      disp.LoadXT(items[aItem].fileN);
      disp.LoadXTpg(1);
    end;
  end;
end;

procedure Home; far;
var i : Integer;
begin
  with menu do begin
    if items[aItem].kind=3 then Exit;
    for i:=1 to 30 do if items[i].kind=3 then begin
      aItem:=i;
      RefreshItems;
      disp.LoadXT(items[aItem].fileN);
      disp.LoadXTpg(1);
    end;
  end;
end;

procedure TApplication.Draw;
var tmp_b : TZone;
begin
  SetFillStyle(1,colorBG);
  Bar(0,0,GetMaxX,GetMaxY);
  New(ObjT);
  with ObjT^ do begin
    x1:=0;
    y1:=0;
    x2:=GetMaxX;
    y2:=GetMaxY;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=nil;
    key:=[];
    desc:='Witaj!';
    kind:=1;
  end;
  ObjT^.Add;

  SetFillStyle(1,colorBT);
  Bar(1,GetMaxY-13,GetMaxX-1,GetMaxY-1);
  SetColor(color1);
  Line(0,GetMaxY-14,0,GetMaxY);
  Line(0,GetMaxY-14,GetMaxX,GetMaxY-14);
  SetColor(color2);
  Line(GetMaxX,GetMaxY-14,GetMaxX,GetMaxY);
  Line(0,GetMaxY,GetMaxX,GetMaxY);

  ShLine(4,GetMaxY-12,4,GetMaxY-3);
  ShLine(140,GetMaxY-12,140,GetMaxY-3);

  New(ObjT);
  with ObjT^ do begin
    x1:=0;
    y1:=GetMaxY-14;
    x2:=GetMaxX;
    y2:=GetMaxY;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=nil;
    key:=[];
    desc:='Autor programu: Sebastian Stoff';
    kind:=1;
  end;
  ObjT^.Add;
  RefreshHint;

{  SetColor(9);
  SetTextStyle(1,0,4);
  OutTextXY(397,GetMaxY-55,'Sebastian Stoff');
  SetColor(1);
  OutTextXY(398,GetMaxY-54,'Sebastian Stoff');
  SetTextStyle(0,0,0);}

  SetFillStyle(1,colorBT);
  Bar(1,1,GetMaxX-1,13);
  SetColor(color1);
  Line(0,0,GetMaxX,0);
  Line(0,0,0,14);
  SetColor(color2);
  Line(0,14,GetMaxX,14);
  Line(GetMaxX,0,GetMaxX,14);

  ShLine(4,2,4,10);
  SetColor(colorTX);
  OutTextXY(9,4,title);
  ShLine(GetMaxX-58,2,GetMaxX-58,10);
  New(ObjT);
  with ObjT^ do begin
    x1:=0;
    y1:=0;
    x2:=GetMaxX;
    y2:=14;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=nil;
    key:=[];
    desc:='Autor programu: Sebastian Stoff';
    kind:=1;
  end;
  ObjT^.Add;

  New(ObjT);
  with ObjT^ do begin
    x1:=GetMaxX-19;
    y1:=2;
    x2:=GetMaxX-4;
    y2:=12;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
{    ppp:=@TApplication.finish;
    Move(ppp,OnClick,4);}
    OnClick:=finish_;
    key:=[1];
    desc:='Wyjcie :(';
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='X';
    Draw;
  end;
  ObjT^.Add;

  New(ObjT);
  with ObjT^ do begin
    x1:=GetMaxX-35;
    y1:=2;
    x2:=GetMaxX-22;
    y2:=12;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=Info;
    key:=[59];
    desc:='Informacje podstawowe';
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='i';
    Draw;
  end;
  ObjT^.Add;

  New(ObjT);
  with ObjT^ do begin
    x1:=GetMaxX-53;
    y1:=2;
    x2:=GetMaxX-38;
    y2:=12;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=Help;
    key:=[53];
    desc:='Pomoc';
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='?';
    Draw;
  end;
  ObjT^.Add;

  if clock then begin
    with tmp_b do begin
      x1:=GetMaxX-55;
      y1:=GetMaxy-12;
      x2:=GetMaxX-3;
      y2:=GetMaxy-2;
      text:='';
      pressed:=t_;
      default:=f_;
      Draw;
    end;
    ShLine(GetMaxX-60,GetMaxY-12,GetMaxX-60,GetMaxY-3);
    RefreshClock;
  end;
end;

procedure TApplication.NewHint;
begin
  hint1:=msg1;
  hint2:=msg2;
  RefreshHint;
end;

procedure TApplication.RefreshHint;
begin
  if (oldHint1=hint1) and (oldHint2=hint2) then Exit;
  SetTextJustify(0,2);
  SetColor(app.colorBT);
  HideMouse;
  SetTextStyle(0,0,0);
  if oldHint1<>hint1 then OutTextXY(9,GetMaxY-10,oldHint1);
  if oldHint2<>hint2 then OutTextXY(145,GetMaxY-10,oldHint2);

  SetColor(app.colorTX);
  if oldHint1<>hint1 then OutTextXY(9,GetMaxY-10,hint1);
  if oldHint2<>hint2 then OutTextXY(145,GetMaxY-10,hint2);
  ShowMouse;
  oldHint1:=hint1;
  oldHint2:=hint2;
end;

procedure TApplication.Done;
begin
  KillAll;
  HideMouse;
  CloseGraph;
  WriteLn;
  WriteLn(app.title);
  WriteLn(app.copyright);
  Halt;
end;

procedure TMouse.RefreshMouse;
begin
  GetMousePos(mx,my,mb);
end;

procedure TApplication.RefreshClock;
var hh,mm,ss : Word;
    s        : String[10];
begin
  GetTime(hh,mm,ss,ss);
  s:=i2s(hh)+':'+pz(mm,2);
  if s<>oldClock then begin
    HideMouse;
    SetTextJustify(2,2);
    SetColor(app.colorBT);
    SetTextStyle(0,0,0);
    OutTextXY(GetMaxX-7,GetMaxY-10,oldClock);

    oldClock:=s;
    SetColor(app.colorTX);
    OutTextXY(GetMaxX-7,GetMaxY-10,s);
    ShowMouse;
    SetTextJustify(0,2);
  end;
end;

procedure TZone.Add;
begin
 Inc(app.nxtid);
 objT^.Id:=app.nxtid;
 if fifo=nil then fifo:=objT
   else fifoC^.nxt:=objT;
  objT^.nxt:=nil;
  fifoC:=objT;
end;

procedure TApplication.KillAll;
begin
  while fifo<>nil do begin
    objT:=fifo^.nxt;
    dispose(fifo);
    fifo:=objT;
  end;
end;

procedure TApplication.Objects;
var bb1,bb2 : Boolean;
begin
  keyP:=Hi(GetKey);
  objT:=fifo;
  while objT<>nil do begin
    if LookMouse(objT^) then activeItem:=objT^;
    if (keyP>0) and (keyP in objT^.key) then begin
      CKB;
      if objT^.kind=2 then begin
        objT^.PressButton;
        Delay(100);
        objT^.PressButton;
      end;
      if @objT^.OnClick<>nil then objT^.OnClick;
    end;
    objT:=objT^.nxt;
  end;
  with activeItem do NewHint(hint1,lastActiveItem.desc);
  if (lastActiveItem.id<>activeItem.id) then begin
    if (@lastActiveItem.OnMoveOut<>nil) then lastActiveItem.OnMoveOut;
    lastActiveItem:=activeItem;
  end;
  with activeItem do if @OnMoveIn<>nil then OnMoveIn;
  if app.mb=1 then begin
    bb1:=f_; bb2:=f_;
    repeat
      app.RefreshMouse;
      with activeItem do begin
        if InKey(app.mx,app.my,x1,y1,x2,y2)
          then bb1:=t_ else bb1:=f_;
        if bb1=bb2 then continue else bb2:=bb1;
        if kind=2 then PressButton;
      end;
    until (app.mb=0) or (activeitem.kind=1);
    with activeItem do begin
      if (bb2) or (kind=1) then begin
        if kind=2 then PressButton;
        if @OnClick<>nil then OnClick;
      end;
    end;
  end;
end;

function TApplication.LookMouse;
begin
  if (mx>=obj.x1) and (mx<=obj.x2) and (my>=obj.y1) and (my<=obj.y2) then
    LookMouse:=t_ else LookMouse:=f_;
end;

procedure TZone.Draw;
var brd : byte;
begin
  HideMouse;
  if default then brd:=2 else brd:=1;
  SetFillStyle(1,app.colorBT);
  Bar(x1+brd,y1+brd,x2-brd,y2-brd);
  ShBorder(x1,y1,x2,y2,pressed,default);

  SetColor(app.colorTX);
  SetTextStyle(0,0,0);
  OutTextXY((x1+(x2-x1) div 2)-(Length(text)*4)+1,(y1+(y2-y1) div 2)-3,text);
  ShowMouse;
end;

procedure TZone.PressButton;
var size : Word;
    buf  : Pointer;
begin
  HideMouse;
  pressed:=not pressed;
  if default then begin
    size:=ImageSize(x1+2,y1+2,x2-2,y2-2);
    GetMem(buf,size);
    GetImage(x1+2,y1+2,x2-2,y2-2,buf^);
    if not pressed then putimage(x1+1,y1+1,buf^,0)
      else putimage(x1+3,y1+3,buf^,0);
    FreeMem(buf,size);

    ShBorder(x1,y1,x2,y2,pressed,default);
    setcolor(7);
    if not pressed then begin
      line(x2-2,y1+2,x2-2,y2-2);
      line(x1+2,y2-2,x2-2,y2-2);
    end else begin
      line(x1+2,y1+2,x2-2,y1+2);
      line(x1+2,y1+2,x1+2,y2-2);
    end;
  end else begin
    size:=ImageSize(x1+1,y1+1,x2-1,y2-1);
    GetMem(buf,size);
    GetImage(x1+1,y1+1,x2-1,y2-1,buf^);
    if not pressed then putimage(x1+0,y1+0,buf^,0)
      else putimage(x1+2,y1+2,buf^,0);
    FreeMem(buf,size);

    ShBorder(x1,y1,x2,y2,pressed,default);
    setcolor(7);
    if not pressed then begin
      line(x2-1,y1+1,x2-1,y2-1);
      line(x1+1,y2-1,x2-1,y2-1);
    end else begin
      line(x1+1,y1+1,x2-1,y1+1);
      line(x1+1,y1+1,x1+1,y2-1);
    end;
  end;
  ShowMouse;
end;

procedure TMenu.FollowMouse;
var i : Integer;
begin
  for i:=1 to 30 do
    if menu.items[i].is then with menu do
      if InKey(app.mx,app.my,x-5,y+15*(i-1)-2,x+width+5,y+15*(i-1)+10) then
        if lastLighted=i then exit else begin
        HideMouse;
        SetTextStyle(0,0,0);
        SetColor(15);
        OutTextXY(x+13*(items[i].depth-1),y+15*(i-1),items[i].title);
        lastLighted:=i;
        ShowMouse;
      end;
end;

procedure TMenu.MouseOut;
begin
  HideMouse;
  SetTextStyle(0,0,0);
  with menu do begin
    if lastLighted>0 then begin
       if lastLighted<>aItem then SetColor(9) else SetColor(14);
       OutTextXY(x+13*(items[lastLighted].depth-1),y+15*(lastLighted-1),items[lastLighted].title);
    end;
    lastLighted:=0;
  end;
  ShowMouse;
end;

procedure TMenu.Draw;
begin
  HideMouse;

  x:=x1+20;
  y:=y1+45;
  height:=y2-7-y;
  width:=x2-x1-40;
  aItem:=0;
  lastLighted:=0;
  SetFillStyle(1,app.colorBT);
  Bar(x1+1,y1+1,x2-1,y2-1);
  ShBorder(x1,y1,x2,y2,f_,t_);

  SetFillStyle(1,app.colorBG);
  Bar(x1+6,y1+32,x2-6,y2-6);
  ShBorder(x1+5,y1+31,x2-5,y2-5,t_,t_);

  ShBorder(x1+6,y1+5,x2-6,y1+26,f_,f_);
  SetColor(15);
  SetTextStyle(1,0,4);
  SetUserCharSize(1,1,4,7);
  OutTextXY(x1+56,y1+6,tit);
  SetColor(0);
  OutTextXY(x1+54,y1+4,tit);
  Refresh;

  ShowMouse;

  New(ObjT);
  ObjT^.x1:=x1;
  ObjT^.y1:=y1;
  ObjT^.x2:=x2;
  ObjT^.y2:=y2;
  with ObjT^ do begin
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=nil;
    key:=[];
    desc:='Menu: Wybierz zagadnienie klikniciem myszy';
    kind:=1;
  end;
  ObjT^.Add;
end;

procedure TMenu.AddItem;
var i : Integer;
begin
  if aItem=0 then aItem:=1;
  for i:=1 to 30 do
    if not items[i].is then with items[i] do begin
      is:=t_;
      depth:=d;
      title:=tit;
      fileN:=fn;
      kind:=k;
      New(ObjT);
      with ObjT^ do begin
        x1:=x-5;
        y1:=y+15*(i-1)-2;
        x2:=x+width+5;
        y2:=y+15*(i-1)+10;
        ppp:=@TMenu.FollowMouse;
        Move(ppp,OnMoveIn,4);
        ppp:=@TMenu.MouseOut;
        Move(ppp,OnMoveOut,4);
        ppp:=@TMenu.Choose;
        Move(ppp,OnClick,4);
        key:=[72,80];
        desc:=des;
        kind:=1;
      end;
      ObjT^.Add;
      exit;
    end;
end;

procedure TMenu.Refresh;
var i       : Integer;
    ors     : LongInt;
    textura : Word;
begin
  HideMouse;
  SetFillStyle(1,app.colorBG);
  Bar(x-5,y-2,x+width+5,y+height);

  ors:=RandSeed;
  RandSeed:=0;
  SetColor(0);
  textura:=Round(width/10*height);
  For i:=1 to textura do begin
    MoveTo(Rnd(x-10,x+width+10),Rnd(y-12,y+height-3));
    case Random(3) of
      0 : PutPixel(Rnd(x-10,x+width+10),Rnd(y-12,y+height),0);
      1 : LineRel(0,Random(3)+1);
      2 : LineRel(Random(3)+1,0);
    end;
  end;
  RandSeed:=ors;

  ShowMouse;
  if aItem>0 then begin
    RefreshItems;
    disp.LoadXT(items[aItem].fileN);
    disp.LoadXTpg(1);
  end;
end;

procedure TMenu.RefreshItems;
var i : Integer;
begin
  HideMouse;
  SetTextStyle(0,0,0);
  SetTextJustify(LeftText,TopText);
  for i:=1 to 30 do
    if items[i].is then with menu.items[i] do begin
      if i<>aItem then SetColor(9) else SetColor(14);
      if i=lastLighted then SetColor(15);
      OutTextXY(menu.x+13*(depth-1),menu.y+15*(i-1),title);
    end;
  ShowMouse;
end;

procedure TMenu.Choose;
var i   : Integer;
    lst : Integer;
begin
  if app.keyP>0 then begin
    with menu do begin
      lst:=aItem;
      if (app.keyP=80) and items[aItem+1].is then aItem:=aitem+1;
      if (app.keyP=72) and (aItem>1) then aItem:=aitem-1;
      if lst<>aItem then begin
        RefreshItems;
        disp.LoadXT(items[aItem].fileN);
        disp.LoadXTpg(1);
      end;
    end;
    app.keyP:=0;
  end else begin
    for i:=1 to 30 do
      if menu.items[i].is then with menu do begin
        if InKey(app.mx,app.my,x-5,y+15*(i-1)-2,x+width+5,y+15*(i-1)+10) then
          if aItem=i then exit else begin
            aItem:=i;
            disp.LoadXT(items[aItem].fileN);
            disp.LoadXTpg(1);
            RefreshItems;
        end;
      end;
  end;
end;

procedure TDisplay.Draw;
begin
  width:=410;
  height:=hgh;
  x:=x1;
  y:=y1;
  histP:=0;
  FillChar(hist,SizeOf(hist),0);
  consol.x:=x+6;
  consol.y:=y+38;
  consol.height:=height-45;
  consol.width:=width-12;

  HideMouse;
  setfillstyle(1,7);
  bar(x1,y1,x1+width,y1+height);
  ShBorder(x1,y1,x1+width,y1+hgh,f_,t_);
  setfillstyle(1,0);
  bar(x1+6,y1+20,x1+width-6,y1+height-6);
  SetColor(15);
  Rectangle(x1+5,y1+37,x1+width-5,y1+height-5);
  Rectangle(x1+5,y1+20,x1+width-5,y1+37);
  New(ObjT);
  with ObjT^ do begin
    x1:=x+330;
    x2:=x+390;
    y1:=y+5;
    y2:=y+17;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
{    ppp:=@TApplication.finish;
    Move(ppp,OnClick,4);}
    OnClick:=finish_;
    key:=[];
    desc:='Wyjcie :(';
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='Koniec';
    Draw;
  end;
  ObjT^.Add;
  New(ObjT);
  with ObjT^ do begin
    x1:=x+270;
    x2:=x+320;
    y1:=y+5;
    y2:=y+17;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    ppp:=@TDisplay.HsNxtPage;
    Move(ppp,OnClick,4);
    key:=[52];
    desc:='Historia: wprzd';
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='>>>';
    Draw;
  end;
  ObjT^.Add;
  New(ObjT);
  with ObjT^ do begin
    x1:=x+210;
    x2:=x+260;
    y1:=y+5;
    y2:=y+17;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    ppp:=@TDisplay.HsPrvPage;
    Move(ppp,OnClick,4);
    desc:='Historia: wstecz';
    key:=[51];
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='<<<';
    Draw;
  end;
  ObjT^.Add;
  New(ObjT);
  with ObjT^ do begin
    x1:=x+150;
    x2:=x+200;
    y1:=y+5;
    y2:=y+17;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    ppp:=@TDisplay.XTNxtPage;
    Move(ppp,OnClick,4);
    desc:='Strona nastepna';
    kind:=2;
    key:=[13,78,77,73]; {+ -> PgUp}
    pressed:=f_;
    default:=f_;
    text:='+';
    Draw;
  end;
  ObjT^.Add;
  New(ObjT);
  with ObjT^ do begin
    x1:=x+90;
    x2:=x+140;
    y1:=y+5;
    y2:=y+17;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    ppp:=@TDisplay.XTPrvPage;
    Move(ppp,OnClick,4);
    desc:='Strona poprzednia';
    key:=[12,74,75,81]; {- <- PgDn}
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='-';
    Draw;
  end;
  ObjT^.Add;
  New(ObjT);
  with ObjT^ do begin
    x1:=x+20;
    x2:=x+80;
    y1:=y+5;
    y2:=y+17;
    OnMoveIn:=nil;
    OnMoveOut:=nil;
    OnClick:=Home;
    key:=[71];{home}
    desc:='Pocztek';
    kind:=2;
    pressed:=f_;
    default:=f_;
    text:='Start';
    Draw;
  end;
  ObjT^.Add;
  ShowMouse;
  NewTitle('','');
end;

procedure TDisplay.NewTitle;
begin
  title1:=t1;
  title2:=t2;
  HideMouse;
  SetFillStyle(1,0);
  Bar(x+6,y+21,x+width-6,y+36);
  SetColor(7);
  SetTextStyle(0,0,0);
  SetTextJustify(LeftText,TopText);
  OutTextXY(x+10,y+26,title1);
  SetTextJustify(RightText,TopText);
  OutTextXY(x+width-7,y+26,title2);
  ShowMouse;
end;

procedure TDisplay.HsPrvPage;
begin
  with disp do begin
    if histP=1 then Exit;
    Dec(histP);
    if hist[histP].mi<>menu.aItem then
      disp.LoadXT(menu.items[hist[histP].mi].fileN);
    menu.aItem:=hist[histP].mi;
    menu.RefreshItems;
    Dec(histP);{sztuczne zanizenie}
    disp.LoadXTpg(hist[histP+1].pg);
  end;
end;

procedure TDisplay.HsNxtPage;
begin
  with disp do begin
    if (histP=50) or (hist[histP+1].mi=0) then Exit;
    Inc(histP);
    if hist[histP].mi<>menu.aItem then
      disp.LoadXT(menu.items[hist[histP].mi].fileN);
    menu.aItem:=hist[histP].mi;
    menu.RefreshItems;
    Dec(histP);{sztuczne zanizenie}
    disp.LoadXTpg(hist[histP+1].pg);
  end;
end;

procedure TDisplay.XTNxtPage;
begin
  with disp do
  if XTPage<XTTotal then begin
    Inc(XTPage);
    disp.LoadXTpg(XTPage);
  end;
end;

procedure TDisplay.XTPrvPage;
begin
  with disp do
  if XTPage>1 then begin
    Dec(XTPage);
    disp.LoadXTpg(XTPage);
  end;
end;

function TDisplay.LoadXT;
var txt : Text;
    comm  : record
              cm : String;
              ArB: array[1..3] of Integer;
              ArS: array[1..3] of String[25];
            end;
    i,j,k : Integer;
    sr,sc : String;
    cp    : Boolean;
    ec    : Byte;
    line  : Integer;
  procedure GetComm(sou : String);
  var wyn  : String;
      cnt  : Integer;
      bg   : Byte;
      ArBc,ArSc : Byte;
      i,c  : Integer;
  begin
    wyn:='';
    bg:=2;
    cnt:=1;
    ArBc:=1;
    ArSc:=1;
    FillChar(comm,SizeOf(comm),0);

    while sou[bg]=' 'do Inc(bg);
    while bg<=Length(sou) do begin
      if not (sou[bg] in [' ','}',';']) then wyn:=wyn+sou[bg]
      else begin
        while (wyn[1]=' ') do begin
          wyn:=Copy(wyn,2,Length(wyn)-1);
        end;
        if cnt=1 then comm.cm:=StringUp(wyn) else begin
          Val(wyn,i,c);
          if c=0 then begin
            if ArBc<=3 then begin
              comm.ArB[ArBc]:=i;
              Inc(ArBc);
            end;
          end else begin
            if wyn[1]='^' then wyn:=Copy(wyn,2,Length(wyn)-1);
            for i:=1 to Length(wyn) do
              if wyn[i]='_' then wyn[i]:=' ';
            if ArSc<=3 then begin
              comm.ArS[ArSc]:=wyn;
              Inc(ArSc);
            end;
          end;
        end;
        wyn:='';
        Inc(cnt);
      end;
      Inc(bg);
    end;
  end;
label fin;
begin
  app.NewHint('Wczytuj...',app.hint2);
  ec:=0;
  XTFile:=fn;
  Assign(txt,fn);
  FileMode:=0;
  {$i-}
  Reset(txt);
  {$i+}
  if ioresult<>0 then begin ec:=1; goto fin; end;
  XTTotal:=1;
  line:=1;
  XTList[XTTotal]:=line;
  while not EOF(txt) do begin
    {$i-}
    ReadLn(txt,sr);
    {$i+}
    if ioresult<>0 then begin ec:=1; Break; end;
    i:=1;
    sc:='';
    cp:=False;
    while i<=length(sr) do begin
      if sr[i]='{' then begin
        Neg(cp);
        if sc='{' then cp:=False;
      end;
      if cp then sc:=sc+sr[i];
      if (sr[i] in ['}',';']) and cp then begin
        GetComm(sc);
        if sr[i]=';' then sc:='{' else begin
          cp:=False;
          sc:='';
        end;
        if comm.cm='PG' then begin
          Inc(XTTotal);
          XTList[XTTotal]:=line;
        end;
      end;
      Inc(i);
    end;
    Inc(line);
  end;
fin:
  {$i-}
  Close(txt);
  {$i+}
  if ioresult<>0 then ec:=1;
  LoadXT:=ec;
  if ec=0 then app.NewHint('Gotowe!',app.hint2)
    else app.NewHint('Bd!',app.hint2);
end;

function TDisplay.LoadXTpg;
var txt : Text;
    comm  : record
              cm : String;
              ArB: array[1..3] of Integer;
              ArS: array[1..3] of String[35];
            end;
    dy    : Integer;
    i,j,k : Integer;
    ii    : Integer;
    sr,sc : String;
    st,stT: String;
    cp    : Boolean;
    ec    : Byte;
    line  : Integer;
    dir   : String[20];
    dirG  : Boolean;
label nxt,out;
  procedure OutXT;
  begin
    case aa.j of
      0 : begin xPlot:=2; SetTextJustify(LeftText,TopText); end;
      1 : begin xPlot:=consol.width div 2; SetTextJustify(CenterText,TopText); end;
      2 : begin xPlot:=consol.width-2; SetTextJustify(RightText,TopText); end;
    end;
    case aa.f of
      0 : begin SetTextStyle(0,0,aa.h); dy:=TextHeight('Jj')+3; end;
      1 : begin SetTextStyle(1,0,aa.h); dy:=TextHeight('Jj')+5; end;
      2 : begin SetTextStyle(2,0,aa.h); dy:=TextHeight('Jj')+7; end;
      3 : begin SetTextStyle(6,0,aa.h); dy:=TextHeight('Jj')+10; end;
    end;
    SetColor(aa.c);
    if st='' then Exit;
    if st[Length(st)]=' ' then st[0]:=Chr(Ord(st[0])-1);

    HideMouse;
    OutTextXY(xPlot,yPlot,st);
    if aa.s=1 then OutTextXY(xPlot+1,yPlot,st);

    st:='';
    ShowMouse;
    inc(yPlot,dy);
    if yPlot>consol.height then ec:=1;
  end;
  procedure GetComm(sou : String);
  var wyn  : String;
      cnt  : Integer;
      bg   : Byte;
      ArBc,ArSc : Byte;
      i,c  : Integer;
  begin
    wyn:='';
    bg:=2;
    cnt:=1;
    ArBc:=1;
    ArSc:=1;
    FillChar(comm,SizeOf(comm),0);

    while sou[bg]=' 'do Inc(bg);
    while bg<=Length(sou) do begin
      if not (sou[bg] in [' ','}',';']) then wyn:=wyn+sou[bg]
      else begin
        while (wyn[1]=' ') do begin
          wyn:=Copy(wyn,2,Length(wyn)-1);
        end;
        if cnt=1 then comm.cm:=StringUp(wyn) else begin
          Val(wyn,i,c);
          if c=0 then begin
            if ArBc<=3 then begin
              comm.ArB[ArBc]:=i;
              Inc(ArBc);
            end;
          end else begin
            if wyn[1]='^' then wyn:=Copy(wyn,2,Length(wyn)-1);
            for i:=1 to Length(wyn) do
              if wyn[i]='_' then wyn[i]:=' ';
            if ArSc<=3 then begin
              comm.ArS[ArSc]:=wyn;
              Inc(ArSc);
            end;
          end;
        end;
        wyn:='';
        Inc(cnt);
      end;
      Inc(bg);
    end;
  end;
label fin;
begin
  app.NewHint('Wczytuj...',app.hint2);
  if nr>XTTotal then Exit;
  XTPage:=nr;
  ec:=0;
  dir:='';
  dirG:=False;
  for i:=Length(XTFile) downto 1 do begin
    if XTFile[i] in ['\','/'] then dirG:=True;
    if dirG then dir:=XTFile[i]+dir;
  end;
  if histP=50 then Move(hist[2],hist[1],SizeOf(hist[1])*49) else Inc(histP);
  hist[histP].mi:=menu.aItem;
  hist[histP].pg:=nr;

  Assign(txt,XTFile);
  FileMode:=0;
  {$i-}
  Reset(txt);
  {$i+}
  if ioresult<>0 then begin ec:=1; goto fin; end;
  yPlot:=3;
  aa.h:=0;
  aa.f:=0;
  aa.j:=1;
  aa.c:=7;
  aa.s:=0;
  SetViewPort(consol.x,consol.y,consol.x+consol.width,consol.y+consol.height,true);
  HideMouse;
  ClearViewPort;
  st:='';
  line:=1;
  while not EOF(txt) do begin
    {$i-}
    ReadLn(txt,sr);
    {$i+}
    if (line<=XTList[nr]) and (line>1) then goto nxt;
    if ioresult<>0 then begin ec:=1; Break; end;
    i:=1;
    sc:='';
    cp:=False;
    while i<=length(sr) do begin
      if sr[i]='{' then begin
        Neg(cp);
        if sc='{' then cp:=False;
      end;
      if not cp then begin
        st:=st+sr[i];
        if TextWidth(st)>consol.width-1 then
          for j:=Length(st) downto 1 do
            if st[j]=' ' then
              if TextWidth(Copy(st,1,j-1))<=consol.width-1 then begin
                stT:=Copy(st,j+1,Length(st)-j);
                st:=Copy(st,1,j);
                OutXT;
                st:=stT;
                Break;
              end;
        if TextWidth(st)>consol.width-1 then
          for j:=Length(st) downto 1 do
            if TextWidth(Copy(st,1,j))<=consol.width-1 then begin
              stT:=Copy(st,j+1,Length(st)-j);
              st:=Copy(st,1,j);
              OutXT;
              st:=stT;
              Break;
            end;
      end else sc:=sc+sr[i];
      if (sr[i] in ['}',';']) and cp then begin
        GetComm(sc);
        if sr[i]=';' then sc:='{' else begin
          cp:=False;
          sc:='';
        end;
        with comm do begin
          if cm='CL' then begin aa.c:=ArB[1]; OutXT; end;
          if cm='H' then begin aa.h:=ArB[1]; OutXT; end;
          if cm='F' then begin aa.f:=ArB[1]; OutXT; end;
          if cm='S' then begin aa.s:=ArB[1]; OutXT; end;
          if cm='L' then aa.j:=0;
          if cm='#' then st:=st+Chr(ArB[1]);
          if cm='C' then aa.j:=1;
          if cm='R' then aa.j:=2;
          if cm='SY' then Inc(yPlot,ArB[1]);
          if cm='HR' then begin
            OutXT;
            if (ArB[1]=0) or (ArB[1]>100) then ArB[1]:=100;
            ii:=Round((consol.width-20)/100*ArB[1]) div 2;
            SetColor(7);
            Graph.Line(consol.width div 2-ii,yPlot,consol.width div 2+ii,yPlot);
            SetColor(8);
            Graph.Line(consol.width div 2-ii,yPlot+2,consol.width div 2+ii,yPlot+2);
            Inc(yPlot,5);
          end;
          if cm='BR' then begin
            if ArB[1]=0 then ArB[1]:=1;
            for ii:=1 to ArB[1] do begin
              if st='' then st:=' ';
              OutXT;
            end;
          end;
          if cm='PG' then goto Out;
          if cm='IMG' then begin
            OutXT;
            if Load16c(dir+ArS[1],0)>0 then ec:=1;
          end;
          if cm='TITLE' then title1:=ArS[1];
        end;
      end;
      if (i=Length(sr)) and (st<>'') then st:=st+' ';
      Inc(i);
      if ec>0 then goto out;
    end;
nxt:
    Inc(line);
  end;
out:
  OutXT;
  SetViewPort(0,0,GetMaxX,GetMaxY,true);
  NewTitle(title1,i2s(XTPage)+'/'+i2s(XTTotal));
  ShowMouse;
  SetTextJustify(LeftText,TopText);
fin:
  {$i-}
  Close(txt);
  {$i+}
  if ioresult<>0 then ec:=1;
  LoadXTpg:=ec;
  if ec=0 then app.NewHint('Gotowe!',app.hint2)
    else app.NewHint('Bd!',app.hint2);
end;

function TDisplay.Load16c;
var f   : File;
    p   : Pointer;
    blk : Byte;
    dlu : Word;
    outX,ys : Integer;
    ct,ec   : Byte;
    err     : Word;
    xx,yy   : Integer;
label fin;
begin
  ec:=0;
  assign(f,fn);
  FileMode:=0;
  {$i-}
  reset(f,1);
  {$i+}
  if ioresult<>0 then begin ec:=1; goto fin; end;
  seek(f,oft);
    BlockRead(f,blk,1);
    BlockRead(f,dlu,2);
    GetMem(p,dlu);
    yy:=0;
    for ct:=1 to blk do begin
      {$i-}
      BlockRead(f,p^,dlu,err);
      {$i+}
      xx:=memw[seg(p^):ofs(p^)]+1;
      ys:=memw[seg(p^):ofs(p^)+2]+1;
      case aa.j of
        0 : outX:=xPlot+3;
        1 : outX:=xPlot-xx div 2;
        2 : outX:=xPlot-3-xx;
      end;
      inc(yy,ys);
      if (ioresult=0) and (yPlot+ys<consol.width) then PutImage(outX,yPlot,p^,0) else begin ec:=1; Break; end;
      inc(yPlot,ys);
    end;
    Inc(yPlot,2);
    FreeMem(p,dlu);
fin:
  {$i-}
  close(f);
  {$i+}
  if ioresult<>0 then ec:=1;
  Load16c:=ec;
end;

procedure OutTextXY;
const Mazovia : array[1..18] of Byte=  {AaCcEeLlNnOoSsXxZz}
 (143,134,149,141,144,145,156,146,165,164,163,162,152,158,160,166,161,167);
      BezOgon : array[1..18] of Byte=
 (065,097,067,099,069,101,076,108,078,110,079,111,083,115,090,122,090,122);
      ToConvert : set of Byte=
 [143,134,149,141,144,145,156,146,165,164,163,162,152,158,160,166,161,167];
var i,j      : Integer;
    xs,ys    : Integer;
    TextInfo : TextSettingsType;
begin
  GetTextSettings(TextInfo);
  if (TextInfo.Font<>0) or (TextInfo.Direction<>0) or (TextInfo.CharSize>1)
     then begin
      Graph.OutTextXY(x,y,txt);
      Exit;
    end;
  case TextInfo.Horiz of
    0 : xs:=0;
    1 : xs:=-Length(txt)*4;
    2 : xs:=-Length(txt)*8;
  end;
  case TextInfo.Vert of
    0 : ys:=8;
    1 : ys:=4;
    2 : ys:=0;
  end;

  for i:=1 to length(txt) do begin
    if Ord(txt[i]) in ToConvert then
    for j:=1 to 18 do if ord(txt[i])=Mazovia[j] then begin
      case j of
        1,2,5,6 : begin
            line(xs+x+8*(i-1)+4,ys+y+9,xs+x+8*(i-1)+6,ys+y+7);
          end;
        3,9,11,13 : begin
            line(xs+x+8*(i-1)+3,ys+y-2,xs+x+8*(i-1)+4,ys+y-3);
          end;
        4,10,12,14,16 : begin
            line(xs+x+8*(i-1)+3,ys+y,xs+x+8*(i-1)+4,ys+y-1);
          end;
        7 : begin
            line(xs+x+8*(i-1)+2,ys+y+3,xs+x+8*(i-1)+4,ys+y+1);
          end;
        8 : begin
            line(xs+x+8*(i-1)+2,ys+y+3,xs+x+8*(i-1)+5,ys+y+1);
          end;
        17 : begin
            line(xs+x+8*(i-1)+3,ys+y-2,xs+x+8*(i-1)+3,ys+y-2);
          end;
        18 : begin
            line(xs+x+8*(i-1)+3,ys+y,xs+x+8*(i-1)+3,ys+y);
          end;
      end;
      txt[i]:=chr(BezOgon[j]); Break;
    end;
  end;
  Graph.OutTextXY(x,y,txt);
end;

begin
  RegisterBGIdriver(@egavgadriverproc);{#9}
  RegisterBGIfont(@TripFontProc);{1}
  RegisterBGIfont(@LittFontProc);{2}
  RegisterBGIfont(@SimpFontProc);{6}
  with app do begin
    finished:=False;
    nxtid:=0;
    oldHint1:='';
    oldHint2:='';
    oldClock:='';
    colorBG:=1;
    colorBT:=7;
    colorTX:=0;
    color1:=15;
    color2:=8;
    clock:=true;
    lastActiveItem.id:=0;
    mode:=2;
    hint1:='Initializing...';
    hint2:='Welcome!';
  end;
end.